echo off
echo .
echo ............................................................
echo Select [0-2] to program flash code, or 3 to exit
echo ............................................................
echo .
echo 0 - ATMx2xx-x1x
echo 1 - ATM33xx-5
echo 2 - ATM34xx-2
echo 3 - exit
echo .

SET APP_EXAMPLE=HCI_vendor

SET /P PLT_SEL=Type 0, 1, 2, 3 then press ENTER:
if %PLT_SEL%==0 goto ATMX2XX-X1X
if %PLT_SEL%==1 goto ATM33XX-5
if %PLT_SEL%==2 goto ATM34XX-2
if %PLT_SEL%==3 goto END

:ATMX2XX-X1X
SET CHIP_VER=ATMx2xx-x1x
echo .
echo ............................................................
echo Select [0-8] to program HCI_vendor flash code, or 9 to exit
echo ............................................................
echo .
echo 0 - ATMEVK_M2201
echo 1 - ATMEVK_M2202
echo 2 - ATMEVK_M2221
echo 3 - ATMEVK_M2231
echo 4 - ATMEVK_M2251
echo 5 - ATMEVK_M3201
echo 6 - ATMEVK_M3202
echo 7 - ATMEVK_M3221
echo 8 - ATMEVK_M3231
echo .

SET /P SEL=Type 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 then press ENTER:
if %SEL%==0 (
        set BOARD=ATMEVK_M2201
        goto RUN
        )
if %SEL%==1 (
        set BOARD=ATMEVK_M2202
        goto RUN
        )
if %SEL%==2 (
        set BOARD=ATMEVK_M2221
        goto RUN
        )
if %SEL%==3 (
        set BOARD=ATMEVK_M2231
        goto RUN
        )
if %SEL%==4 (
        set BOARD=ATMEVK_M2251
        goto RUN
        )
if %SEL%==5 (
        set BOARD=ATMEVK_M3201
        goto RUN
)
if %SEL%==6 (
        set BOARD=ATMEVK_M3202
        goto RUN
)
if %SEL%==7 (
        set BOARD=ATMEVK_M3221
        goto RUN
)
if %SEL%==8 (
        set BOARD=ATMEVK_M3231
        goto RUN
)
if %SEL%==9 goto END

:ATM33XX-5
SET CHIP_VER=ATM33xx-5
echo .
echo ............................................................
echo Select [0-6] to program HCI_vendor flash code, or 7 to exit
echo ............................................................
echo .
echo 0 - ATMEVK_3325_LQK
echo 1 - ATMEVK_3325_QK
echo 2 - ATMEVK_3325_TAG
echo 3 - ATMEVK_3325_CM
echo 4 - ATMEVK_3330_QN
echo 5 - ATMEVK_3330e_QN
echo 6 - ATMEVK_3330e_QN_7
echo .

SET /P SEL=Type 0, 1, 2, 3, 4, 5 then press ENTER:
if %SEL%==0 (
        set BOARD=ATMEVK_3325_LQK
        goto RUN
        )
if %SEL%==1 (
        set BOARD=ATMEVK_3325_QK
        goto RUN
        )
if %SEL%==2 (
        set BOARD=ATMEVK_3325_TAG
        goto RUN
        )
if %SEL%==3 (
        set BOARD=ATMEVK_3325_CM
        goto RUN
        )
if %SEL%==4 (
        set BOARD=ATMEVK_3330_QN
        goto RUN
        )
if %SEL%==5 (
        set BOARD=ATMEVK_3330e_QN
        goto RUN
        )
if %SEL%==6 (
        set BOARD=ATMEVK_3330e_QN_7
        goto RUN
        )
if %SEL%==7 goto END

:ATM34XX-2
SET CHIP_VER=ATM34xx-2
echo .
echo ............................................................
echo Select [0-1] to program HCI_vendor/CHCI flash code,
echo Select [2] to program HCI_vendor flash code, or 3 to exit
echo ............................................................
echo .
echo 0 - ATMEVK_3430e_WQN_2
echo 1 - ATMEVK_3425_DQK_2
echo 2 - ATMEVK_3405_DQK_2

SET /P SEL=Type 0, 1, 2 then press ENTER:
if %SEL%==0 (
        set BOARD=ATMEVK_3430e_WQN_2
        goto ATM34XX-2-EXAMPLE
        )
if %SEL%==1 (
        set BOARD=ATMEVK_3425_DQK_2
        goto ATM34XX-2-EXAMPLE
        )
if %SEL%==2 (
        set BOARD=ATMEVK_3405_DQK_2
        goto RUN
        )
if %SEL%==3 goto END

:ATM34XX-2-EXAMPLE
SET CHIP_VER=ATM34xx-2
echo .
echo ............................................................
echo Select [0-1] to program HCI_vendor or CHCI flash code, or 2 to exit
echo ............................................................
echo .
echo 0 - HCI_vendor
echo 1 - CHCI

SET /P SEL=Type 0, 1 then press ENTER:
if %SEL%==0 (
        set APP_EXAMPLE=HCI_vendor
        goto RUN
        )
if %SEL%==1 (
        set APP_EXAMPLE=CHCI
        goto RUN
        )
if %SEL%==2 goto END

:RUN
SET FTDI_BENIGN_BOOT=1
SET FTDI_HARD_RESET=1
SET PATH_OPENOCD_TCL_BASE=.\\fw_image\\openocd-0.10.0\\tcl
SET PATH_OPENOCD_EXE=.\\fw_image\\openocd-0.10.0\\openocd.exe
SET PATH_FW=.\\fw_image\\%CHIP_VER%\\%APP_EXAMPLE%_%BOARD%.elf
SET PATH_BOOTLOADER=.\\fw_image\\%CHIP_VER%\\bootloader.elf
SET PATH_OPENOCD_TCL=.\\fw_image\\%CHIP_VER%\\openocd

if %PLT_SEL% GEQ 1 (
SET PATH_OPENOCD_CFG=.\\fw_image\\%CHIP_VER%\\openocd\\atmx3_openocd.cfg
)else (
SET PATH_OPENOCD_CFG=.\\fw_image\\%CHIP_VER%\\openocd\\atm2x_openocd.cfg
)

%PATH_OPENOCD_EXE% -s %PATH_OPENOCD_TCL_BASE% -s %PATH_OPENOCD_TCL% -f %PATH_OPENOCD_CFG% -c "init; exit"
SET FTDI_HARD_RESET=0
%PATH_OPENOCD_EXE% -s %PATH_OPENOCD_TCL_BASE% -s %PATH_OPENOCD_TCL% -f %PATH_OPENOCD_CFG% -c "init; exit"
SET FTDI_BENIGN_BOOT=0
%PATH_OPENOCD_EXE% -s %PATH_OPENOCD_TCL_BASE% -s %PATH_OPENOCD_TCL% -f %PATH_OPENOCD_CFG% -c "init; sleep 200; set_normal_boot; exit"


SET FTDI_BENIGN_BOOT=
SET FTDI_HARD_RESET=
if %PLT_SEL% GEQ 1 (
%PATH_OPENOCD_EXE% -s %PATH_OPENOCD_TCL_BASE% -s %PATH_OPENOCD_TCL% -f %PATH_OPENOCD_CFG% -c "init; verify_rom_version; atm_load_rram %PATH_FW%; atm_load_rram %PATH_BOOTLOADER%; set _RESET_HARD_ON_EXIT 1; exit"
)else (
%PATH_OPENOCD_EXE% -s %PATH_OPENOCD_TCL_BASE% -s %PATH_OPENOCD_TCL% -f %PATH_OPENOCD_CFG% -c "init; verify_rom_version; sydney_load_flash %PATH_FW%; set _RESET_HARD_ON_EXIT 1; exit"
)

goto END

:END
echo exit